/***************************************************************************
*    Copyright 2000  Broadcom Corporation
*    All Rights Reserved
*    No portions of this material may be reproduced in any form without the
*    written permission of:
*             Broadcom Corporation
*             16251 Laguna Canyon Road
*             Irvine, California  92618
*    All information contained in this document is Broadcom Corporation
*    company private, proprietary, and trade secret.
*
****************************************************************************
*
*    Filename: tftp.c
*    Creation Date: 28 June 2001 (v0.00)
*    VSS Info:
*        $Revision: 1.1 $
*        $Date: 2002/08/21 17:54:44 $
*
****************************************************************************
*    Description:
*
*     Broadcom Generic Operating System Functions. This file contains a VxWorks
*     specific implementation of trivial file transfer protocol (TFTP).
*
****************************************************************************/

#include <hausenv.h>
#include <string.h>
#include <bcmos.h>

/* Operating system specific includes */
#include <vxWorks.h>
#include "socket.h"



/*****************************************************************************
** FUNCTION:   bcmOsTftpReadFile
**
** PURPOSE:    This function reads the specified file from the specified TFTP
**             server, placing the file data in the buffer.
**             Up to "bufferSize" bytes of the file will be read.
**
** PARAMETERS: serverIpAddress (I)  - the IP address of the TFTP server.
**             pFilename       (I)  - the fully qualified name of the file
**                                    to be read.
**             ifno            (I)  - IP Iface # over which the TFTP is performed
**             pBuffer         (O)  - buffer with retrieved data.
**             bufferSize      (I)  - Size of the buffer.
**             pBytesRead      (O)  - the number of bytes actually read.
**
** RETURNS:    0 if OK, error code - otherwise
**
** NOTE:
*****************************************************************************/
OS_STATUS bcmOsTftpReadFile(  IPADDR serverIpAddress,
                              char *pFilename,
                              UINT32 ifno,
                              char *pBuffer,
                              UINT32 bufferSize,
                              UINT32 *pBytesRead,
                              OS_ABORT_FNC abortFunc
                           )
{
   NATIVE_SOCKET_STATUS  status = ERROR;

   /* Error checking */
   return ( checkSocketStatus( status, "bcmOsTftpReadFile" ));
}
