/***************************************************************************
*    Copyright 2000  Broadcom Corporation
*    All Rights Reserved
*    No portions of this material may be reproduced in any form without the
*    written permission of:
*             Broadcom Corporation
*             16251 Laguna Canyon Road
*             Irvine, California  92618
*    All information contained in this document is Broadcom Corporation
*    company private, proprietary, and trade secret.
*
****************************************************************************
*
*    Filename: osdef.h
*    Creation Date: 28 June 2001 (v0.00)
*    VSS Info:
*        $Revision: 1.1 $
*        $Date: 2002/08/21 17:54:28 $
*
****************************************************************************
*    Description:
*
*      Private Broadcom generic operating system prototypes and type defines.
*
****************************************************************************/

#ifndef _OSDEF_H
#define _OSDEF_H

#ifdef __cplusplus
extern "C" {
#endif


/*
*****************************************************************************
** EXPORTS
*****************************************************************************
*/
/* OS-dependent socket options */
extern UINT32 osSockOpt[OS_SOCKET_OPT_MAX];


/*
*****************************************************************************
** FUNCTION PROTOTYPES
*****************************************************************************
*/

/*****************************************************************************
** FUNCTION:   osInit
**
** PURPOSE:    initialize any os specific variables
**
** PARAMETERS: None
**
** RETURNS:    OS_STATUS
*****************************************************************************/
OS_STATUS osInit( void );


/*****************************************************************************
** FUNCTION:   bcmOsTaskPriority
**
** PURPOSE:    To retrieve the absolute task priority based upon the task class
**
** PARAMETERS: taskClass [IN] - the type of MTA class
**             priority [OUT] - priority level
**
** RETURNS:    OS_STATUS
*****************************************************************************/
OS_STATUS bcmOsTaskPriority( OS_TASK_CLASS taskClass, UINT32 *priority );


/*****************************************************************************
** FUNCTION:   bcmOsTaskClass
**
** PURPOSE:    To retrieve the task class based upon the absolute task priority
**
** PARAMETERS: priority [IN]     - OS-specific, absolute task priority
**             taskClass [OUT]   - task class types
**
** RETURNS:    OS_STATUS
*****************************************************************************/
OS_STATUS bcmOsTaskClass( UINT32 priority, OS_TASK_CLASS *taskClass );

/*****************************************************************************
** FUNCTION:   bcmOsConvertSocketOptions
**
** PURPOSE:    To convert from OS-independent value to OS-dependent ones.
**
** PARAMETERS: offset      - offset into the OS-dependent array
**
** RETURNS:    OS_STATUS
******************************************************************************/
UINT32 bcmOsConvertSocketOptions(OS_SOCKOPT offset);


#ifdef __cplusplus
    }
#endif

#endif  /* _OSDEF_H  */


