/***************************************************************************
*    Copyright 2001  Broadcom Corporation
*    All Rights Reserved
*    No portions of this material may be reproduced in any form without the
*    written permission of:
*             Broadcom Corporation
*             16251 Laguna Canyon Road
*             Irvine, California  92618
*    All information contained in this document is Broadcom Corporation
*    company private, proprietary, and trade secret.
*
****************************************************************************
*
*    Filename: timeTable.h
*    Creation Date: 6 November 2001 (v0.00)
*    VSS Info:
*        $Revision: 1.1 $
*        $Date: 2002/08/21 17:54:34 $
*
****************************************************************************
*    Description:
*
*      Header file for Implementation time management for the ticket, 
*      session key and subkey
*
****************************************************************************/

#ifndef TIMETABLE_H
#define TIMETABLE_H



#ifdef __cplusplus
extern "C"
{
#endif


#include <string.h>
#include <SecLib.h>
#include <krb5client.h>

/*
******************************************************************************
** FUNCTION:  secStoreToTimeTable
**
** PURPOSE:   Store info for ticket or subkey to keep track of its expiry
**
** PARAMETERS:   flag - AS or AP, prove or CMS
**               cmsfqdn - fqdn of cms
**               realm - realm 
**               credentials - ticket and session key
**               appkey  -  subkey
**
** RETURNS:
**
** NOTE:
**
******************************************************************************
*/
void secStoreToTimeTable(
      SEC_MSG_FLAG         flag, 
      unsigned char        *cmsfqdn,
	  unsigned char        *realm,
      MtaCredentials       *credentials, 
      MtaApplicationKey    *appkey);


/*
******************************************************************************
** FUNCTION:  secUpdateTimeTable
**
** PURPOSE:  renew any ticket or subkey if expired 
**
** PARAMETERS:   the time between sleeps for the krb task
**
** RETURNS:
**
** NOTE:
**
******************************************************************************
*/
void secUpdateTimeTable(unsigned short sleep_time);

#endif
